

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Start-of-day memory layout &mdash; Xen 4.16-unstable documentation</title>
  

  
  
  
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
  

  

  
        <link rel="index" title="Index"
              href="../../genindex.html"/>
        <link rel="search" title="Search" href="../../search.html"/>
    <link rel="top" title="Xen 4.16-unstable documentation" href="../../index.html"/>
        <link rel="up" title="Hypercall Interfaces - arm64" href="../arm64.html"/>
        <link rel="next" title="Dom0 console" href="dom0_console.html"/>
        <link rel="prev" title="Start-of-day shared data structure" href="start_of_day_shared_data_structure.html"/> 

  
  <script src="../../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">

   
  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../../index.html" class="icon icon-home"> Xen
          

          
          </a>

          
            
            
              <div class="version">
                4.16
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../admin-guide/index.html">Admin Guide</a></li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../guest-guide/index.html">Guest documentation</a></li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../hypervisor-guide/index.html">Hypervisor documentation</a></li>
</ul>
<ul class="current">
<li class="toctree-l1 current"><a class="reference internal" href="../index.html">Hypercall Interfaces</a><ul class="current">
<li class="toctree-l2 current"><a class="reference internal" href="../arm64.html">Hypercall Interfaces - arm64</a><ul class="current">
<li class="toctree-l3 current"><a class="reference internal" href="../arm64.html#starting-points">Starting points</a><ul class="current">
<li class="toctree-l4"><a class="reference internal" href="hypercall_calling_convention.html">Hypercall Calling Convention</a></li>
<li class="toctree-l4"><a class="reference internal" href="supported_hypercalls.html">Supported hypercalls</a></li>
<li class="toctree-l4"><a class="reference internal" href="list_of_hypercalls.html">List of hypercalls</a></li>
<li class="toctree-l4"><a class="reference internal" href="guest_scheduler_operations.html">Guest Scheduler Operations</a></li>
<li class="toctree-l4"><a class="reference internal" href="grant_tables.html">Grant Tables</a></li>
<li class="toctree-l4"><a class="reference internal" href="event_channels.html">Event Channels</a></li>
<li class="toctree-l4"><a class="reference internal" href="xenstore_wire_protocol.html">XenStore wire protocol</a></li>
<li class="toctree-l4"><a class="reference internal" href="start_of_day_shared_data_structure.html">Start-of-day shared data structure</a></li>
<li class="toctree-l4 current"><a class="current reference internal" href="#">Start-of-day memory layout</a></li>
<li class="toctree-l4"><a class="reference internal" href="dom0_console.html">Dom0 console</a></li>
<li class="toctree-l4"><a class="reference internal" href="xen_elfnote_features.html">XEN ELFNOTE FEATURES</a></li>
<li class="toctree-l4"><a class="reference internal" href="elf_notes.html">ELF notes</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#functions">Functions</a></li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#structs">Structs</a></li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#enums-and-sets-of-defines">Enums and sets of #defines</a></li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#typedefs">Typedefs</a></li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#enum-values-and-individual-defines">Enum values and individual #defines</a></li>
</ul>
</li>
</ul>
</li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../glossary.html">Glossary</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">Xen</a>
        
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../index.html">Hypercall Interfaces</a> &raquo;</li>
        
          <li><a href="../arm64.html">Hypercall Interfaces - arm64</a> &raquo;</li>
        
      <li>Start-of-day memory layout</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../../_sources/hypercall-interfaces/common/start_of_day_memory_layout.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <div class="section" id="start-of-day-memory-layout">
<h1>Start-of-day memory layout<a class="headerlink" href="#start-of-day-memory-layout" title="Permalink to this headline">¶</a></h1>
<dl class="group">
<dt>
<span class="target" id="group__start__of__day__memory__layout"></span><em>group</em> <code class="descname">start_of_day_memory_layout</code></dt>
<dd><p>Start-of-day memory layout. </p>
<p><ol class="arabic simple">
<li>The domain is started within contiguous virtual-memory region.</li>
<li>The contiguous region ends on an aligned 4MB boundary.</li>
<li>This the order of bootstrap elements in the initial virtual region: a. relocated kernel image b. initial ram disk [mod_start, mod_len] (may be omitted) c. list of allocated page frames [mfn_list, nr_pages] (unless relocated due to XEN_ELFNOTE_INIT_P2M) d. start_info_t structure [register rSI (x86)] in case of dom0 this page contains the console info, too e. unless dom0: xenstore ring page f. unless dom0: console ring page g. bootstrap page tables [pt_base and CR3 (x86)] h. bootstrap stack [register ESP (x86)]</li>
<li>Bootstrap elements are packed together, but each is 4kB-aligned.</li>
<li>The list of page frames forms a contiguous ‘pseudo-physical’ memory layout for the domain. In particular, the bootstrap virtual-memory region is a 1:1 mapping to the first section of the pseudo-physical map.</li>
<li>All bootstrap elements are mapped read-writable for the guest OS. The only exception is the bootstrap page table, which is mapped read-only.</li>
<li>There is guaranteed to be at least 512kB padding after the final bootstrap element. If necessary, the bootstrap virtual region is extended by an extra 4MB to ensure this.</li>
</ol>
</p>
<p>Note: Prior to 25833:bb85bbccb1c9. (“x86/32-on-64 adjust Dom0 initial page
table layout”) a bug caused the pt_base (3.g above) and cr3 to not point to the start of the guest page tables (it was offset by two pages). This only manifested itself on 32-on-64 dom0 kernels and not 32-on-64 domU or 64-bit kernels of any colour. The page tables for a 32-on-64 dom0 got allocated in the order: ‘first L1’,’first L2’, ‘first L3’, so the offset to the page table base is by two pages back. The initial domain if it is 32-bit and runs under a 64-bit hypervisor should <em>NOT</em> use two of the pages preceding pt_base and mark them as reserved/unused. </p>
<div class="breathe-sectiondef docutils container">
<p class="breathe-sectiondef-title rubric">Defines</p>
<dl class="define">
<dt id="c.SIF_PRIVILEGED">
<span class="target" id="group__start__of__day__memory__layout_1ga8ecf593b678f4bdec9ac01310922c1c0"></span><code class="descname">SIF_PRIVILEGED</code> (1&lt;&lt;0)  /* Is the domain privileged? */<a class="headerlink" href="#c.SIF_PRIVILEGED" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.SIF_INITDOMAIN">
<span class="target" id="group__start__of__day__memory__layout_1ga78a3b1c7fb7a528e30bb880e92d52127"></span><code class="descname">SIF_INITDOMAIN</code> (1&lt;&lt;1)  /* Is this the initial control domain? */<a class="headerlink" href="#c.SIF_INITDOMAIN" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.SIF_MULTIBOOT_MOD">
<span class="target" id="group__start__of__day__memory__layout_1ga1f2e63bba48cbb521a33818104fde9b7"></span><code class="descname">SIF_MULTIBOOT_MOD</code> (1&lt;&lt;2)  /* Is mod_start a multiboot module? */<a class="headerlink" href="#c.SIF_MULTIBOOT_MOD" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.SIF_MOD_START_PFN">
<span class="target" id="group__start__of__day__memory__layout_1gaae2b5474c251f7943d8bf8300acc41e7"></span><code class="descname">SIF_MOD_START_PFN</code> (1&lt;&lt;3)  /* Is mod_start a PFN? */<a class="headerlink" href="#c.SIF_MOD_START_PFN" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.SIF_VIRT_P2M_4TOOLS">
<span class="target" id="group__start__of__day__memory__layout_1ga8124315d233cbb9b60daf52373f4fd42"></span><code class="descname">SIF_VIRT_P2M_4TOOLS</code> (1&lt;&lt;4) /* Do Xen tools understand a virt. mapped */<a class="headerlink" href="#c.SIF_VIRT_P2M_4TOOLS" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.SIF_PM_MASK">
<span class="target" id="group__start__of__day__memory__layout_1gabc4acb66a1a27ad5f3888540bbca4bc4"></span><code class="descname">SIF_PM_MASK</code> (0xFF&lt;&lt;8) /* reserve 1 byte for xen-pm options */<a class="headerlink" href="#c.SIF_PM_MASK" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</div>
</dd></dl>

</div>


           </div>
           <div class="articleComments">
            
           </div>
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="dom0_console.html" class="btn btn-neutral float-right" title="Dom0 console" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="start_of_day_shared_data_structure.html" class="btn btn-neutral" title="Start-of-day shared data structure" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2019, The Xen development community.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../../',
            VERSION:'4.16-unstable',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true,
            SOURCELINK_SUFFIX: '.txt'
        };
    </script>
      <script type="text/javascript" src="../../_static/jquery.js"></script>
      <script type="text/javascript" src="../../_static/underscore.js"></script>
      <script type="text/javascript" src="../../_static/doctools.js"></script>

  

  
  
    <script type="text/javascript" src="../../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
      });
  </script>
   

</body>
</html>